]> git.madduck.net Git - code/vcsh.git/blobdiff - vcsh

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Use exit and {} instead of return and ()
[code/vcsh.git] / vcsh
diff --git a/vcsh b/vcsh
index c05210d2b67e83e0ec43c5972748d747fcc96232..8ba0f2709ee62fd3e0a982bc80af0886e88fea6b 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -5,14 +5,6 @@
 [ -z "$VCSH_BASE" ]       && VCSH_BASE="$XDG_CONFIG_HOME/vcsh/repo.d"
 
 SELF=$(basename $0)
-if [ "$SELF" = 'bash' ] ||
-   [ "$SELF" = 'dash' ] ||
-   [ "$SELF" = 'sh' ] ||
-   [ "$SELF" = 'zsh' ]; then
-       SELF='vcsh'
-       VCSH_SOURCED=1
-fi
-
 
 help() {
        echo "usage: $SELF <args>
@@ -22,7 +14,6 @@ help() {
    help                 Display this help text
    delete               Delete an existing repository
    enter                Enter repository; spawn new $SHELL
-   exit                 Exit repository; unset ENV
    init <repo>          Initialize a new repository
    list                 List all repositories
    run <repo> \\
@@ -31,7 +22,6 @@ help() {
    seed-gitignore \\
    <repo>               Seed .gitignore.d/<repo> from git ls-files
    setup                Set up repository with recommended settings
-   use <repo>           Use repository; set ENV
 
    <repo> <git command> Special command that allows you to run git commands
                         directly without having to type so much ;)" >&2
@@ -57,29 +47,22 @@ init() {
        verbose "init() begin"
        [ -e "$GIT_DIR" ] &&
                echo "$SELF: fatal: $GIT_DIR exists" &&
-               return 21
+               return 10
        export GIT_WORK_TREE="$HOME"
        mkdir -p "$GIT_WORK_TREE"
        cd "$GIT_WORK_TREE" ||
-               (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                return 1) || return $?
+               { echo "$SELF: fatal: could not enter $GIT_WORK_TREE"; return 11; }
        cd "$GIT_WORK_TREE"
        git init
        setup
        verbose "init() end"
 }
 
-leave() {
-       unset GIT_DIR
-       unset GIT_WORK_TREE
-       unset VCSH_DIRECTORY
-}
-
 use() {
        verbose "use() begin"
        if [ ! -d "$GIT_DIR" ]; then
                echo E: no repository found for "$VCSH_REPO_NAME" >&2
-               return 1
+               return 12
        fi
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
@@ -101,27 +84,25 @@ elif [ "$1" = 'delete' ] ||
      [ "$1" = 'init' ] ||
      [ "$1" = 'run' ] ||
      [ "$1" = 'seed-gitignore' ] ||
-     [ "$1" = 'setup' ] ||
-     [ "$1" = 'use' ]; then
-       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
+     [ "$1" = 'setup' ]; then
+       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && exit 1
        export VCSH_COMMAND="$1"
        export VCSH_REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
        shift 2
        export VCSH_EXTERNAL_COMMAND="$*"
        if [ "$VCSH_COMMAND" = 'run' ]; then
-               [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
+               [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && exit 1
        fi
-elif [ "$1" = 'exit' ] ||
-     [ "$1" = 'help' ] ||
+elif [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
        export VCSH_COMMAND="$1"
 else
-       [ -z $1 ] && help && return 0
+       [ -z $1 ] && help && exit 0
        export VCSH_COMMAND='run'
        export VCSH_REPO_NAME="$1"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       [ -d $GIT_DIR ] || (help && return 1) || return 0
+       [ -d $GIT_DIR ] || { help; exit 1; }
        shift 1
        export VCSH_EXTERNAL_COMMAND="git $*"
 fi
@@ -131,11 +112,11 @@ for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
 do
        if [ ! -d "$check_directory" ]; then
                if [ -e "$check_directory" ]; then
-                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       return 2
+                       echo "$SELF: fatal: $check_directory exists but is not a directory" >&2
+                       exit 13
                else
                        echo "$SELF: info: attempting to create $check_directory"
-                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
+                       mkdir -p "$check_directory" || { echo "$SELF: fatal: could not create $check_directory" >&2; exit 50; }
                fi
        fi
 done
@@ -156,9 +137,8 @@ if [ "$VCSH_COMMAND" = 'clone' ]; then
        [ "$VCSH_CONFLICT" = '1' ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-               return 3
+               exit 17
        git merge origin/master
-#      use || return $?
        verbose "clone end"
 
 #elif [ "$VCSH_COMMAND" = 'help' ] || [ "$#" -eq 0 ]; then
@@ -169,7 +149,7 @@ elif [ "$VCSH_COMMAND" = 'delete' ]; then
        verbose "delete begin"
        old_dir="$PWD"
        cd "$HOME"
-       use || return $?
+       use || exit $?
        echo "$SELF: info: This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
@@ -179,7 +159,7 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
        read answer
-       [ "x$answer" = "xYes, do as I say" ] || return 1
+       [ "x$answer" = "xYes, do as I say" ] || exit 16
        for file in $files; do
                rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
        done
@@ -189,27 +169,13 @@ To continue, type \"Yes, do as I say\""
 
 elif [ "$VCSH_COMMAND" = 'enter' ]; then
        verbose "enter begin"
-       use || return $?
+       use || exit $?
        $SHELL
-       leave
        verbose "enter end"
 
-elif [ "$VCSH_COMMAND" = 'exit' ]; then
-       verbose "exit begin"
-#      if [ -n "$ZSH_VERSION" ] && [ "$VCSH_NO_IGNORE_EOF" = '1' ]; then
-#              unset VCSH_NO_IGNORE_EOF
-#              setopt NO_IGNORE_EOF
-#      fi
-       [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
-       leave
-#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-       verbose "exit end"
-       return 0
-
 elif [ "$VCSH_COMMAND" = 'init' ]; then
        verbose "init begin"
        init
-#      use || return $?
        verbose "init end"
 
 elif [ "$VCSH_COMMAND" = 'list' ]; then
@@ -221,14 +187,13 @@ elif [ "$VCSH_COMMAND" = 'list' ]; then
 
 elif [ "$VCSH_COMMAND" = 'run' ]; then
        verbose "run begin"
-       use || return $?
+       use || exit $?
        $VCSH_EXTERNAL_COMMAND
-       leave
        verbose "run end"
 
 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        verbose "seed-gitignore begin"
-       use || return $?
+       use || exit $?
        # Switching directory as this has to be executed from $HOME to be of any use.
        # Going back into old directory at the end in case `vcsh use` is reactivated.
        old_dir="$PWD"
@@ -241,7 +206,7 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
                done;
        done | sort -u)
        tempfile=$(mktemp) ||
-               (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
+               { echo "$SELF: fatal: could not create tempfile"; exit 51; }
        echo '*' > "$tempfile"
        for gitignore in $gitignores; do
                echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
@@ -249,48 +214,27 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        done
        diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
                rm -f "$tempfile" &&
-               return
+               exit
        if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
                echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
                mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
-                        return 1) || return $?
+                       { echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"; exit 53; }
        fi
        mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
+               { echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && exit 53; }
        cd "$old_dir"
        verbose "seed-gitignore end"
 
 elif [ "$VCSH_COMMAND" = 'setup' ]; then
        verbose "seed-gitignore begin"
-       use   || return $?
-       setup || return $?
-       leave
+       use   || exit $?
+       setup || exit $?
        verbose "seed-gitignore end"
 
-elif [ "$VCSH_COMMAND" = 'use' ]; then
-       verbose "use begin"
-#      if [ -n "$ZSH_VERSION" ]; then
-#              if [ -o NO_IGNORE_EOF ]; then
-#                      export VCSH_NO_IGNORE_EOF=1
-#                      setopt IGNORE_EOF
-#              fi
-#              vcsh_exit() {
-#                      vcsh exit;
-#                      zle reset-prompt;
-#              }
-#              zle -N vcsh_exit
-#              bindkey '^d' 'vcsh_exit'
-#      fi
-       [ -z "$VCSH_SOURCED" ] && echo "$SELF $VCSH_COMMAND: You need to source vcsh if you want to run in this mode" && return 10
-       use || return $?
-#      [ -n "$ZSH_VERSION" ] && [ "$USER" = richih ] && buildPS1
-       verbose "use end"
-
 else
        verbose "defaulting to calling help()"
        help
        echo "$SELF: fatal: You should never reach this code. File a bug, please."
-       return 99
+       exit 99
 
 fi